part of masamune_ads.mobile;

/// Display banner ads.
class AdsBanner extends StatefulWidget {
  /// Display banner ads.
  const AdsBanner({
    required this.unitId,
    this.bannerSize = AdsSize.banner,
  });

  /// Admob advertising ID.
  final String unitId;

  /// Admob banner size.
  final AdsSize bannerSize;

  @override
  State<StatefulWidget> createState() => _AdsBannerState();
}

class _AdsBannerState extends State<AdsBanner> {
  late final BannerAd _bannerAd;

  @override
  void initState() {
    super.initState();
    _bannerAd = BannerAd(
      adUnitId: widget.unitId,
      size: AdSize(
          width: widget.bannerSize.width, height: widget.bannerSize.height),
      request: const AdRequest(),
      listener: const BannerAdListener(),
    );
    _bannerAd.load();
  }

  @override
  void dispose() {
    super.dispose();
    _bannerAd.dispose();
  }

  /// Run build.
  ///
  /// [context]: Build Context.
  @override
  Widget build(BuildContext context) {
    return AdWidget(ad: _bannerAd);
  }
}
